VERSION 5.00
Begin VB.Form Search2Form 
   Caption         =   "Search2"
   ClientHeight    =   5055
   ClientLeft      =   1095
   ClientTop       =   1455
   ClientWidth     =   5610
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   5055
   ScaleWidth      =   5610
   Begin VB.TextBox txtFilePattern 
      Height          =   285
      Left            =   1320
      TabIndex        =   1
      Top             =   480
      Width           =   2895
   End
   Begin VB.TextBox txtResult 
      Height          =   4095
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   3
      Top             =   840
      Width           =   4095
   End
   Begin VB.TextBox txtStartDir 
      Height          =   285
      Left            =   1320
      TabIndex        =   0
      Top             =   120
      Width           =   2895
   End
   Begin VB.CommandButton cmdSearch 
      Cancel          =   -1  'True
      Caption         =   "Search"
      Default         =   -1  'True
      Height          =   495
      Left            =   4320
      TabIndex        =   2
      Top             =   120
      Width           =   1215
   End
   Begin VB.Label Label1 
      Caption         =   "File Pattern"
      Height          =   255
      Index           =   1
      Left            =   120
      TabIndex        =   5
      Top             =   480
      Width           =   1095
   End
   Begin VB.Label Label1 
      Caption         =   "Start Directory"
      Height          =   255
      Index           =   0
      Left            =   120
      TabIndex        =   4
      Top             =   120
      Width           =   1095
   End
End
Attribute VB_Name = "Search2Form"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

#If Win32 Then
    Private Const MAX_PATH = 260
    Private Type FILETIME
        dwLowDateTime As Long
        dwHighDateTime As Long
    End Type
    Private Type WIN32_FIND_DATA
        dwFileAttributes As Long
        ftCreationTime As FILETIME
        ftLastAccessTime As FILETIME
        ftLastWriteTime As FILETIME
        nFileSizeHigh As Long
        nFileSizeLow As Long
        dwReserved0 As Long
        dwReserved1 As Long
        cFileName As String * MAX_PATH
        cAlternate As String * 14
    End Type
    
    Private Declare Function FindFirstFile Lib "kernel32" Alias "FindFirstFileA" (ByVal lpFileName As String, lpFindFileData As WIN32_FIND_DATA) As Long
    Private Declare Function FindNextFile Lib "kernel32" Alias "FindNextFileA" (ByVal hFindFile As Long, lpFindFileData As WIN32_FIND_DATA) As Long
    Private Declare Function FindClose Lib "kernel32" (ByVal hFindFile As Long) As Long
    Private Declare Function GetLastError Lib "kernel32" () As Long
    
    Private Const ERROR_NO_MORE_FILES = 18&
    Private Const INVALID_HANDLE_VALUE = -1
    Private Const DDL_DIRECTORY = &H10
#End If

' Return a list of the files beneath this
' directory that match the pattern.
'
' 28 July 1999
' Fixed a bug that prevented the program from
' working when compiled into an executable.
' Thanks to Wolfgang Pilch (Wolfgang.Pilch@patent.bmwa.gv.at).
'
Private Function FindFiles(ByVal start_dir As String, ByVal file_pattern As String) As String
Dim null_character As String
Dim dirs() As String
Dim num_dirs As Long
Dim sub_dir As String
Dim file_name As String
Dim i As Integer
Dim txt As String
Dim search_handle As Long
Dim file_data As WIN32_FIND_DATA
Dim not_done As Boolean

    ' ASCII character 0 terminates strings.
    null_character = Chr$(0)

    ' Search for matching files in this directory.
    ' Get the first matching file.
    search_handle = FindFirstFile( _
        start_dir & file_pattern, file_data)
    If search_handle <> INVALID_HANDLE_VALUE Then
        ' Save this file's name.
        Do
            file_name = file_data.cFileName
            file_name = Left$(file_name, _
                InStr(file_name, null_character) - 1)
            If file_name <> "." And file_name <> ".." Then
                ' Add the file to the return value.
                txt = txt & start_dir & file_name & vbCrLf
            End If

            ' Get the next file.
            not_done = FindNextFile(search_handle, file_data)
        Loop While not_done

        ' Close the file search hanlde.
        FindClose search_handle
    End If

    ' Get this directory's subdirectories.
    ' Get the first subdirectory.
    search_handle = FindFirstFile( _
        start_dir & "*.*", file_data)
    If search_handle <> INVALID_HANDLE_VALUE Then
        ' Save this file's name.
        Do
            ' Save the subdirectory name.
            If file_data.dwFileAttributes And DDL_DIRECTORY Then
                file_name = file_data.cFileName
                file_name = Left$(file_name, _
                    InStr(file_name, null_character) - 1)
                If file_name <> "." And file_name <> ".." Then
                    num_dirs = num_dirs + 1
                    ReDim Preserve dirs(1 To num_dirs)
                    dirs(num_dirs) = start_dir & file_name & "\"
                End If
            End If

            not_done = FindNextFile(search_handle, file_data)
        Loop While not_done

        ' Close the file search hanlde.
        FindClose search_handle
    End If

    ' Recursively search the subdirectories.
    For i = 1 To num_dirs
        ' Add this subdirectory's matching files
        ' to the result string.
        txt = txt & FindFiles(dirs(i), file_pattern)
    Next i

    ' Return the string we have built.
    FindFiles = txt
End Function

' Initialize the file name.
Private Sub Form_Load()
Dim file_path As String

    #If Win32 = False Then
        MsgBox "This program only works in 32-bit Visual Basic."
        Unload Me
        Exit Sub
    #End If

    file_path = App.Path
    If Right$(file_path, 1) <> "\" Then _
        file_path = file_path & "\"
    txtStartDir.Text = file_path
End Sub

' Search for subdirectories.
Private Sub cmdSearch_Click()
Dim start_dir As String
Dim file_pattern As String

    Screen.MousePointer = vbHourglass
    DoEvents

    start_dir = txtStartDir.Text
    If Right$(start_dir, 1) <> "\" Then _
        start_dir = start_dir & "\"
    file_pattern = txtFilePattern.Text

    txtResult.Text = FindFiles(start_dir, file_pattern)

    Screen.MousePointer = vbDefault
End Sub
